<?php

namespace Drupal\lazy_loading_formatter\Plugin\Field\FieldFormatter;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\responsive_image\Plugin\Field\FieldFormatter\ResponsiveImageFormatter;

/**
 * Plugin implementation of the 'lazy_loading_field_formatter' formatter.
 *
 * @FieldFormatter(
 *   id = "lazy_loading_field_formatter",
 *   label = @Translation("Lazy Responsive image"),
 *   field_types = {
 *     "image"
 *   }
 * )
 */
class LazyLoadingFieldFormatter extends ResponsiveImageFormatter {

  /**
   * {@inheritdoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode) {
    $elements = parent::viewElements($items, $langcode);
    foreach ($elements as &$element) {
      $element["#item_attributes"] = ['data-use-lazy-loading' => TRUE, 'class' => 'lazyload'];
    }
    return $elements;
  }

}
